include masm32rt.inc
.586
include winmm.inc
includelib winmm.lib
inv equ invoke
.data
hpfreq  dq ?    ; high performance counter frequency
fstcnt  dq ?    ; starting timer count
endcnt  dq ?    ; ending timer count
tdelay  dd ?    ; multimedia timer delay wanted
tgot    dd ?    ; actual delay that occured
terr    dd ?
tcode   dd ?
tflag   dd ?
lcnt    dd ?
.data
t1000   dq 1000

.data?
buffx dd 100 dup (?)
mbuff equ offset buffx

.code
TimerDone proc uID,uMSg,dwUser,dw1,dw2  ; call here when multimedia timer is finished
local txx 
    inv QueryPerformanceCounter,addr endcnt
    inv QueryPerformanceFrequency,addr hpfreq
    inv timeEndPeriod,1
    inv timeKillEvent,tcode
    finit
    fild endcnt
    fild fstcnt
    fsub
    fwait
    fild hpfreq
    fdiv
    fild t1000
    fmul
    fist tgot
    mov tflag,0
	ret
TimerDone endp
WaitTest proc
    rdtsc
    and eax,127
    mov tdelay,eax
    inv timeBeginPeriod,1
    .if eax != TIMERR_NOERROR
        inv MessageBox,0,SADD(" timeBeginPeriod error"),0,0
        inv ExitProcess,0
    .endif
	inv QueryPerformanceCounter,addr fstcnt
    inv timeSetEvent,tdelay,1,TimerDone,0,TIME_ONESHOT
    mov tcode,eax
    .if eax==0
       inv MessageBox,0,SADD(" timeSetEvent error"),0,0
       inv ExitProcess,0
    .else
        mov tflag,1
    .endif
	ret
WaitTest endp

program:
    mov lcnt,10
    .repeat
        call WaitTest
        .repeat
            inv Sleep,100
        .until tflag==0
        mov eax,tdelay
        sub eax,tgot
        mov terr,eax
        inv wsprintf,mbuff,SADD("Wanted %3li ms.  Got %3li ms.  Error= %3li ms."),tdelay,tgot,terr
        print mbuff,13,10
        dec lcnt
    .until zero?
    inkey SADD(13,10,"press any key to end")
    inv ExitProcess,0
end program
